# ConstructionBase

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaObjects.github.io/ConstructionBase.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaObjects.github.io/ConstructionBase.jl/dev)
[![Build Status](https://github.com/JuliaObjects/ConstructionBase.jl/workflows/CI/badge.svg)](https://github.com/JuliaObjects/ConstructionBase.jl/actions?query=workflow%3ACI)
[![GitHub stars](https://img.shields.io/github/stars/JuliaObjects/ConstructionBase.jl?style=social)](https://github.com/JuliaObjects/ConstructionBase.jl)

ConstructionBase is a very lightweight package, that provides primitive functions for construction of objects:
```julia
setproperties(obj::MyType, patch::NamedTuple)
constructorof(MyType)
```
These functions can be overloaded and doing so provides interoperability with the following packages:
* [Flatten.jl](https://github.com/rafaqz/Flatten.jl)
* [Setfield.jl](https://github.com/jw3126/Setfield.jl)
* [BangBang.jl](https://github.com/tkf/BangBang.jl)
* [Accessors.jl](https://github.com/JuliaObjects/Accessors.jl)
* [ModelParameters.jl](https://github.com/rafaqz/ModelParameters.jl)

module ConstructionBaseLinearAlgebraExt

import ConstructionBase
import LinearAlgebra

### Tridiagonal

function tridiagonal_constructor(dl::V, d::V, du::V) where {V<:AbstractVector{T}} where T
    LinearAlgebra.Tridiagonal{T,V}(dl, d, du)
end
function tridiagonal_constructor(dl::V, d::V, du::V, du2::V) where {V<:AbstractVector{T}} where T
    LinearAlgebra.Tridiagonal{T,V}(dl, d, du, du2)
end

# `du2` may be undefined, so we need a custom `getfields` that checks `isdefined`
function ConstructionBase.getfields(o::LinearAlgebra.Tridiagonal)
    if isdefined(o, :du2)
        (dl=o.dl, d=o.d, du=o.du, du2=o.du2)
    else
        (dl=o.dl, d=o.d, du=o.du)
    end
end

ConstructionBase.constructorof(::Type{<:LinearAlgebra.Tridiagonal}) = tridiagonal_constructor

### Cholesky

ConstructionBase.setproperties(C::LinearAlgebra.Cholesky, patch::NamedTuple{()}) = C

function ConstructionBase.setproperties(C::LinearAlgebra.Cholesky, patch::NamedTuple{(:L,),<:Tuple{<:LinearAlgebra.LowerTriangular}})
    return LinearAlgebra.Cholesky(C.uplo === 'U' ? copy(patch.L.data') : patch.L.data, C.uplo, C.info)
end
function ConstructionBase.setproperties(C::LinearAlgebra.Cholesky, patch::NamedTuple{(:U,),<:Tuple{<:LinearAlgebra.UpperTriangular}})
    return LinearAlgebra.Cholesky(C.uplo === 'L' ? copy(patch.U.data') : patch.U.data, C.uplo, C.info)
end
function ConstructionBase.setproperties(
    C::LinearAlgebra.Cholesky,
    patch::NamedTuple{(:UL,),<:Tuple{<:Union{LinearAlgebra.LowerTriangular,LinearAlgebra.UpperTriangular}}}
)
    return LinearAlgebra.Cholesky(patch.UL.data, C.uplo, C.info)
end
function ConstructionBase.setproperties(C::LinearAlgebra.Cholesky, patch::NamedTuple)
    throw(ArgumentError("Invalid patch for `Cholesky`: $(patch)"))
end

end #module

### SubArray
# `offset1` and `stride1` fields are calculated from parent indices.
# Setting them has no effect.
subarray_constructor(parent, indices, args...) = SubArray(parent, indices)

constructorof(::Type{<:SubArray}) = subarray_constructor

### ReinterpretArray
struct ReinterpretArrayConstructor{T} end
# `readable` and `writeable` are calculated from `T` and `parent`
# Setting them has no effect.
function (::ReinterpretArrayConstructor{T})(parent, args...) where T
    reinterpret(T, parent)
end

constructorof(::Type{<:Base.ReinterpretArray{T}}) where T = ReinterpretArrayConstructor{T}()

### PermutedDimsArray
struct PermutedDimsArrayConstructor{N,perm,iperm} end
# Parent must have the same N - it has to match length(perm)
function (::PermutedDimsArrayConstructor{N,perm,iperm})(parent::AA
) where {N,perm,iperm,AA<:AbstractArray{T,N}} where T
    PermutedDimsArray{T,N,perm,iperm,AA}(parent)
end

constructorof(::Type{<:PermutedDimsArray{<:Any,N,perm,iperm,<:Any}}) where {N,perm,iperm} =
    PermutedDimsArrayConstructor{N,perm,iperm}()



### LinRange
# `lendiv` is a calculated field
linrange_constructor(start, stop, len, lendiv) = LinRange(start, stop, len)

constructorof(::Type{<:LinRange}) = linrange_constructor

### Expr: args get splatted
# ::Expr annotation is to make it type-stable on Julia 1.3-
constructorof(::Type{<:Expr}) = (head, args) -> Expr(head, args...)::Expr

module ConstructionBaseStaticArraysExt

using ConstructionBase
using StaticArrays

# general static arrays need to keep the size parameter
ConstructionBase.constructorof(sa::Type{<:SArray{S}}) where {S} = SArray{S}
ConstructionBase.constructorof(sa::Type{<:MArray{S}}) where {S} = MArray{S}
ConstructionBase.constructorof(sa::Type{<:SizedArray{S}}) where {S} = SizedArray{S}

# static vectors don't even need the explicit size specification
ConstructionBase.constructorof(::Type{<:SVector}) = SVector
ConstructionBase.constructorof(::Type{<:MVector}) = MVector

# set properties by name: x, y, z, w
@generated function ConstructionBase.setproperties(obj::Union{SVector{N}, MVector{N}}, patch::NamedTuple{KS}) where {N, KS}
    if KS == (:data,)
        :( constructorof(typeof(obj))(only(patch)) )
    else
        N <= 4 || error("type $obj does not have properties $(join(KS, ", "))")
        propnames = (:x, :y, :z, :w)[1:N]
        KS ⊆ propnames || error("type $obj does not have properties $(join(KS, ", "))")
        field_exprs = map(enumerate(propnames)) do (i, p)
            from = p ∈ KS ? :patch : :obj
            :( $from.$p )
        end
        :( constructorof(typeof(obj))($(field_exprs...)) )
    end
end

end

using ConstructionBase
using Test
using LinearAlgebra

struct Empty end
struct AB{A,B}
    a::A
    b::B
end

@testset "constructorof" begin
    @test constructorof(Empty)() === Empty()
    @inferred constructorof(AB{Int, Int})
    @test constructorof(AB{Int, Int})(1, 2) === AB(1,2)
    @test constructorof(AB{Int, Int})(1.0, 2) === AB(1.0,2)
    @test constructorof(typeof((a=1, b=2)))(1.0, 2) === (a=1.0, b=2)
    @test constructorof(NamedTuple{(:a, :b)})(1.0, 2) === (a=1.0, b=2)
    @test constructorof(Tuple)(1.0, 2) === (1.0, 2)
    @test constructorof(Tuple{Nothing, Missing})(1.0, 2) === (1.0, 2)
end

@testset "getfields" begin
    @test getfields(()) === ()
    @test keys(getfields([])) == fieldnames(typeof([]))
    @test getfields(Empty()) === NamedTuple()
    @test getfields(NamedTuple()) === NamedTuple()
    @test getfields((10,20,30)) === (10,20,30)
    @test getfields((a=10,b=20f0,c=true)) === (a=10,b=20f0,c=true)
    @test getfields(AB(1, 10)) === (a=1, b=10)
    adder(a) = x -> x + a
    @test getfields(adder(1)) === (a=1,)
end

struct DontTouchProperties
    a
    b
end
Base.propertynames(::DontTouchProperties) = error()
Base.getproperty(::DontTouchProperties, ::Symbol) = error()
ConstructionBase.getproperties(::DontTouchProperties) = error()
@testset "getfields does not depend on properties" begin
    @test getfields(DontTouchProperties(1,2)) === (a=1, b=2)
    @test constructorof(DontTouchProperties) === DontTouchProperties
end

@testset "getproperties" begin
    o = AB(1, 2)
    @test getproperties(o) === (a=1, b=2)
    @inferred getproperties(o)
    @test getproperties(Empty()) === NamedTuple()

    t = (1,2,3.0)
    @inferred getproperties(t)
    @test t === getproperties(t)
    @test () === getproperties(())
end

@testset "setproperties" begin

    @test setproperties(NamedTuple(), NamedTuple()) === NamedTuple()
    @test setproperties((), NamedTuple()) === ()
    @test setproperties(NamedTuple(), ()) === NamedTuple()
    @test setproperties((), ()) === ()
    @test setproperties(1, ()) === 1
    @test setproperties(1, NamedTuple()) === 1

    @test setproperties((1,), ()) === (1,)
    @test setproperties((1,), NamedTuple()) === (1,)
    @test setproperties((a=1,), ()) === (a=1,)
    @test setproperties((a=1,), NamedTuple()) === (a=1,)
    @test setproperties(AB(1,2), ()) === AB(1,2)
    @test_throws ArgumentError setproperties(AB(1,2), (10,))
    @test setproperties(AB(1,2), NamedTuple()) === AB(1,2)

    @test setproperties(AB(1,2), (a=2, b=3))   === AB(2,3)
    @test setproperties(AB(1,2), (a=2, b=3.0)) === AB(2,3.0)
    @test setproperties(AB(1,2), a=2, b=3.0) === AB(2,3.0)

    res = @test_throws ArgumentError setproperties(AB(1,2), (a=2, this_field_does_not_exist=3.0))
    msg = sprint(showerror, res.value)
    @test occursin("this_field_does_not_exist", msg)

    res = @test_throws ArgumentError setproperties(AB(1,2), a=2, this_field_does_not_exist=3.0)
    msg = sprint(showerror, res.value)
    @test occursin("this_field_does_not_exist", msg)

    @test setproperties(42, NamedTuple()) === 42
    @test setproperties(42) === 42

    @test setproperties(Empty(), NamedTuple()) === Empty()
    @test setproperties(Empty()) === Empty()

    @test setproperties((a=1, b=2), (a=1.0,)) === (a=1.0, b=2)
    @test setproperties((a=1, b=2), a=1.0) === (a=1.0, b=2)

    @inferred setproperties(AB(1,2), a=2, b=3.0)
    @inferred setproperties(Empty(), NamedTuple())
    @inferred setproperties((a=1, b=2), a=1.0)
    @inferred setproperties((a=1, b=2), (a=1.0,))

    @test setproperties((1,), ()) === (1,)
    @test setproperties((1,), (10,)) === (10,)
    @test_throws ArgumentError setproperties((1,), (10,20)) === (10,)

    @inferred setproperties((1,2,3), (1,2,3))
    @test setproperties((1,2,3), ()) === (1,2,3)
    @test setproperties((1,2,3), (10.0,)) === (10.0,2,3)
    @test setproperties((1,2,3), (10.0,20)) === (10.0,20,3)
    @test setproperties((1,2,3), (10.0,20,30)) === (10.0,20,30)
    @test_throws ArgumentError setproperties((1,2,3), (10.0,20,30,40))

    @test_throws ArgumentError setproperties((a=1,b=2), (10,20))
    @test_throws ArgumentError setproperties((), (10,))
    @test_throws ArgumentError setproperties((1,2), (a=10,b=20))
end

struct CustomSetproperties
    _a::Int
end
function ConstructionBase.setproperties(o::CustomSetproperties, patch::NamedTuple)
    if isempty(patch)
        o
    elseif propertynames(patch) == (:a,)
        CustomSetproperties(patch.a)
    else
        error()
    end
end

@testset "custom setproperties unambiguous on empty" begin
    o = CustomSetproperties(1)
    @test o === setproperties(o)
    @test o === setproperties(o, NamedTuple())
    @test CustomSetproperties(2) === setproperties(o, a=2)
    @test CustomSetproperties(2) === setproperties(o, (a=2,))
end

@testset "constructors for non-standadard Base and LinearAlgebra etc objects" begin
    A1 = zeros(5, 6)
    A2 = ones(Float32, 5, 6)

    @testset "SubArray" begin
        subarray = view(A1, 1:2, 3:4)
        @test constructorof(typeof(subarray))(getfields(subarray)...) === subarray
        @test all(constructorof(typeof(subarray))(A2, (Base.OneTo(2), 3:4), 0, 0) .== Float32[1 1; 1 1])
        @inferred constructorof(typeof(subarray))(getfields(subarray)...)
        @inferred constructorof(typeof(subarray))(A2, (Base.OneTo(2), 3:4), 0, 0)
    end

    @testset "ReinterpretArray" begin
        ra1 = reinterpret(Float16, A1)
        @test constructorof(typeof(ra1))(A1) === ra1
        @test constructorof(typeof(ra1))(getfields(ra1)...) === ra1
        ra2 = constructorof(typeof(ra1))(A2)
        @test size(ra2) == (10, 6)
        @test eltype(ra2) == Float16
        @inferred constructorof(typeof(ra1))(getfields(ra1)...)
        @inferred constructorof(typeof(ra1))(A2)
    end

    @testset "PermutedDimsArray" begin
        pda1 = PermutedDimsArray(A1, (2, 1))
        @test constructorof(typeof(pda1))(A1) === pda1
        @test constructorof(typeof(pda1))(getfields(pda1)...) === pda1
        @test eltype(constructorof(typeof(pda1))(A2)) == Float32
        @inferred constructorof(typeof(pda1))(getfields(pda1)...)
        @inferred constructorof(typeof(pda1))(A2)
    end

    @testset "Tridiagonal" begin
        d = randn(12)
        dl = randn(11)
        du = randn(11)
        tda = Tridiagonal(dl, d, du)
        @test isdefined(tda, :du2) == false
        @test constructorof(typeof(tda))(dl, d, du) === tda
        @test constructorof(typeof(tda))(getfields(tda)...) === tda
        # lu factorization defines du2
        tda_lu = lu!(tda).factors
        @test isdefined(tda_lu, :du2) == true
        @test constructorof(typeof(tda_lu))(getfields(tda_lu)...) === tda_lu
        @test constructorof(typeof(tda_lu))(getfields(tda)...) !== tda_lu
        @test constructorof(typeof(tda_lu))(getfields(tda)...) === tda
        @inferred constructorof(typeof(tda))(getfields(tda)...)
        @inferred constructorof(typeof(tda))(getfields(tda_lu)...)
    end

    @testset "LinRange" begin
        lr1 = LinRange(1, 7, 10)
        lr2 = LinRange(1.0f0, 7.0f0, 10)
        @test constructorof(typeof(lr1))(1, 7, 10, nothing) === lr1
        @test constructorof(typeof(lr1))(getfields(lr2)...) === lr2
        @inferred constructorof(typeof(lr1))(getfields(lr1)...)
        @inferred constructorof(typeof(lr1))(getfields(lr2)...)
    end

    @testset "Cholesky" begin
        x = randn(3, 3)
        X = x * x'
        @testset "uplo=$uplo" for uplo in ['L', 'U']
            C = Cholesky(X, uplo, 0)

            # Empty patch.
            C_new = ConstructionBase.setproperties(C, NamedTuple())
            @test typeof(C_new) === typeof(C)
            for f in propertynames(C)
                @test getproperty(C_new, f) == getproperty(C, f)
            end

            # Update `L`.
            C_new = ConstructionBase.setproperties(C, (L=2 * C.L,))
            @test typeof(C_new) === typeof(C)
            for f in propertynames(C)
                @test getproperty(C_new, f) == 2 * getproperty(C, f)
            end

            # Update `U`.
            C_new = ConstructionBase.setproperties(C, (U=2 * C.U,))
            @test typeof(C_new) === typeof(C)
            for f in propertynames(C)
                @test getproperty(C_new, f) == 2 * getproperty(C, f)
            end

            # Update `UL`
            C_new = ConstructionBase.setproperties(C, (UL=2 * C.UL,))
            @test typeof(C_new) === typeof(C)
            for f in propertynames(C)
                @test getproperty(C_new, f) == 2 * getproperty(C, f)
            end

            # We can only set the properties with `LowerTriangular` or `UpperTriangular` matrices.
            @test_throws ArgumentError ConstructionBase.setproperties(C, (L=parent(C.L),))
            @test_throws ArgumentError ConstructionBase.setproperties(C, (U=parent(C.U),))
            # Can only set one at the time.
            @test_throws ArgumentError ConstructionBase.setproperties(C, (L=C.L, U=C.U,))
            @test_throws ArgumentError ConstructionBase.setproperties(C, (UL=C.UL, U=C.U,))
            @test_throws ArgumentError ConstructionBase.setproperties(C, (UL=C.UL, L=C.L,))
            # And make sure any other patch will fail.
            @test_throws ArgumentError ConstructionBase.setproperties(C, (asdf=C.UL,))
        end
    end

    @testset "Expr" begin
        e = :(a + b)
        @test e == @inferred constructorof(typeof(e))(getfields(e)...)
    end
end

@testset "default function constructors" begin
    function multiplyer(a, b)
        x -> x * a * b
    end

    mult11 = multiplyer(1, 1)
    @test mult11(1) === 1
    mult23 = @inferred constructorof(typeof(mult11))(2.0, 3.0)
    @inferred mult23(1)
    @test mult23(1) === 6.0
    multbc = @inferred constructorof(typeof(mult23))("b", "c")
    @inferred multbc("a")
    @test multbc("a") == "abc"

    @test (@inferred constructorof(typeof(sin))()) === sin
    f = x -> x^2
    @test (@inferred constructorof(typeof(f))()) === f
end

struct Adder{V} <: Function
    value::V
end
(o::Adder)(x) = o.value + x

struct Adder2{V} <: Function
    value::V
    int::Int
end
(o::Adder2)(x) = o.value + o.int + x

struct AddTuple{T} <: Function
    tuple::Tuple{T,T,T}
end
(o::AddTuple)(x) = sum(o.tuple) + x

# A function with an inner constructor with checks
struct Rotation{M} <: Function
    matrix::M
    function Rotation(m)
        @assert isapprox(det(m), 1)
        @assert isapprox(m*m', I)
        new{typeof(m)}(m)
    end
end

@testset "Custom function object constructors still work" begin
    add1 = Adder(1)
    @test add1(1) === 2
    add2 = @inferred ConstructionBase.constructorof(typeof(add1))(2.0)
    @inferred add2(1)
    @test add2(1) == 3.0
    add12 = Adder2(1, 2)
    @test @inferred add12(3) ==  6
    add22 = @inferred ConstructionBase.constructorof(typeof(add12))(2.0, 2)
    @test @inferred add22(3) ==  7.0

    addtuple123 = AddTuple((1, 2, 3))
    @test addtuple123(1) === 7
    addtuple234 = @inferred ConstructionBase.constructorof(typeof(addtuple123))((2.0, 3.0, 4.0))
    @inferred addtuple234(1)
    @test addtuple234(1) === 10.0

    @testset "inner constructor without type parameters is still called" begin
        @test_throws AssertionError constructorof(Rotation{Matrix{Float64}})(zeros(3,3))
    end
end

# example of a struct with different fields and properties
struct FieldProps{NT <: NamedTuple{(:a, :b)}}
    components::NT
end

Base.propertynames(::FieldProps) = (:a, :b)
Base.getproperty(obj::FieldProps, name::Symbol) = getproperty(getfield(obj, :components), name)

@testset "use properties, not fields" begin
    x = FieldProps((a=1, b=:b))
    @test constructorof(typeof(x)) === FieldProps
    @test getfields(x) === (components=(a=1, b=:b),)
    res = @test_throws ErrorException setproperties(x, c=0)
    msg = sprint(showerror, res.value)
    @test occursin("overload", msg)
    @test occursin("setproperties", msg)
    @test occursin("FieldProps", msg)
    @test_throws ErrorException setproperties(x, components=(a=1,b=:b))
    msg = sprint(showerror, res.value)
    @test occursin("overload", msg)
    @test occursin("setproperties", msg)
    @test occursin("FieldProps", msg)
    @test_throws ErrorException setproperties(x, a="aaa")
    msg = sprint(showerror, res.value)
    @test occursin("overload", msg)
    @test occursin("setproperties", msg)
    @test occursin("FieldProps", msg)
 # == FieldProps((a="aaa", b=:b)
    if VERSION >= v"1.7"
        @test getproperties(x) == (a=1, b=:b)
    else
        res = @test_throws ErrorException getproperties(x)
        msg = sprint(showerror, res.value)
        @test occursin("overload", msg)
        @test occursin("getproperties", msg)
        @test occursin("FieldProps", msg)
    end
end


struct SProp
    names
end
Base.propertynames(s::SProp) = getfield(s, :names)
Base.getproperty(s::SProp, prop::Symbol) = "ps$prop"
Base.getproperty(s::SProp, prop::Int) = "pi$prop"
Base.getproperty(s::SProp, prop::String) = "pstr$prop"

if VERSION >= v"1.7"
    # automatic getproperties() supported only on 1.7+

    @testset "properties can be numbered" begin
        @test getproperties(SProp((:a, :b))) === (a="psa", b="psb")
        @test getproperties(SProp((1, 2))) === ("pi1", "pi2")
        # what should it return?
        @test_broken getproperties(SProp(("a", "b")))

        @test_throws ErrorException getproperties(SProp((1, :a)))
    end

    @testset "propertynames can be a vector" begin
        @test getproperties(SProp([:a, :b])) === (a="psa", b="psb")
        @test getproperties(SProp(Symbol[])) === (;)
        @test getproperties(SProp([1, 2])) === ("pi1", "pi2")
        @test getproperties(SProp(Int[])) === ()
    end
end

function funny_numbers(::Type{Tuple}, n)::Tuple
    types = [
        Int128, Int16, Int32, Int64, Int8,
        UInt128, UInt16, UInt32, UInt64, UInt8,
        Float16, Float32, Float64,
    ]
    Tuple([T(true) for T in rand(types, n)])
end

function funny_numbers(::Type{NamedTuple}, n)::NamedTuple
    t = funny_numbers(Tuple,n)
    pairs = map(1:n) do i
        Symbol("a$i") => t[i]
    end
    (;pairs...)
end

abstract type S end
Sn_from_n = Dict{Int,Type}()
for n in [0,1,10,20,40]
    Sn = Symbol("S$n")
    types = [Symbol("A$i") for i in 1:n]
    fields = [Symbol("a$i") for i in 1:n]
    typed_fields = [:($ai::$Ai) for (ai,Ai) in zip(fields, types)]
    @eval struct $(Sn){$(types...)} <: S
        $(typed_fields...)
    end
    @eval Sn_from_n[$n] = $Sn
end
function funny_numbers(::Type{S}, n)::S
    fields = funny_numbers(Tuple, n)
    Sn_from_n[n](fields...)
end

reconstruct(obj, content) = constructorof(typeof(obj))(content...)

function write_output_to_ref!(f, out_ref::Ref, arg_ref::Ref)
    arg = arg_ref[]
    out_ref[] = f(arg)
    out_ref
end
function write_output_to_ref!(f, out_ref::Ref, arg_ref1::Ref, arg_ref2::Ref)
    arg1 = arg_ref1[]
    arg2 = arg_ref2[]
    out_ref[] = f(arg1,arg2)
    out_ref
end
function hot_loop_allocs(f::F, args...) where {F}
    # we want to test that f(args...) does not allocate
    # when used in hot loops
    # however a naive @allocated f(args...)
    # will not be representative of what happens in an inner loop
    # Instead it will sometimes box inputs/outputs
    # and report too many allocations
    # so we use Refs to minimize inputs and outputs
    out_ref = Ref(f(args...))
    arg_refs = map(Ref, args)
    write_output_to_ref!(f, out_ref, arg_refs...)
    out_ref = typeof(out_ref)() # erase out_ref so we can assert work was done later
    # Avoid splatting args... which also results in undesired allocs
    allocs = if length(arg_refs) == 1
        r1, = arg_refs
        @allocated write_output_to_ref!(f, out_ref, r1)
    elseif length(arg_refs) == 2
        r1,r2 = arg_refs
        @allocated write_output_to_ref!(f, out_ref, r1, r2)
    else
        error("TODO too many args")
    end
    @assert out_ref[] == f(args...)
    return allocs
end

@testset "no allocs $T" for T in [Tuple, NamedTuple, S]
    @testset "n = $n" for n in [0,1,10,20]
        obj = funny_numbers(T, n)
        new_content = funny_numbers(Tuple, n)
        @test 0 == hot_loop_allocs(constructorof, typeof(obj))
        @test 0 == hot_loop_allocs(reconstruct, obj, new_content)
        @test 0 == hot_loop_allocs(getproperties, obj)
        @test 0 == hot_loop_allocs(getfields, obj)
        patch_sizes = [0,1,n÷3,n÷2,n]
        patch_sizes = min.(patch_sizes, n)
        patch_sizes = unique(patch_sizes)
        for k in patch_sizes
            patch = if T === Tuple
                funny_numbers(Tuple, k)
            else
                funny_numbers(NamedTuple, k)
            end
            @test 0 == hot_loop_allocs(setproperties, obj, patch)
        end
    end
end

struct S2
    a::Union{Nothing, Int}
    b::Union{UInt32, Int32}
end

@testset "no allocs S2" begin
    obj = S2(3, UInt32(5))
    @test 0 == hot_loop_allocs(constructorof, typeof(obj))
    if VERSION < v"1.6"
        @test 32 ≥ hot_loop_allocs(setproperties, obj, (; a = nothing, b = Int32(6)))
    else
        @test 0 == hot_loop_allocs(setproperties, obj, (; a = nothing, b = Int32(6)))
    end
end

@testset "inference" begin
    @testset "Tuple n=$n" for n in [0,1,2,3,4,5,10,20,30,40]
        t = funny_numbers(Tuple,n)
        @test length(t) == n
        @test getproperties(t) === t
        @inferred getproperties(t)
        @test getfields(t) === t
        @inferred getfields(t)
        @inferred constructorof(typeof(t))
        content = funny_numbers(Tuple,n)
        @inferred reconstruct(t, content)
        for k in 0:n
            t2 = funny_numbers(Tuple,k)
            @test setproperties(t, t2)[1:k] === t2
            @test setproperties(t, t2) isa Tuple
            @test length(setproperties(t, t2)) == n
            @test setproperties(t, t2)[k+1:n] === t[k+1:n]
            @inferred setproperties(t, t2)
        end
    end
    @inferred getproperties(funny_numbers(Tuple,100))
    @inferred setproperties(funny_numbers(Tuple,100), funny_numbers(Tuple,90))

    @testset "NamedTuple n=$n" for n in [0,1,2,3,4,5,10,20,30,40]
        nt = funny_numbers(NamedTuple, n)
        @test nt isa NamedTuple
        @test length(nt) == n
        @test getproperties(nt) === nt
        @inferred getproperties(nt)
        @test getfields(nt) === nt
        @inferred getfields(nt)

        @inferred constructorof(typeof(nt))
        if VERSION >= v"1.3"
            content = funny_numbers(NamedTuple,n)
            @inferred reconstruct(nt, content)
        end
        #no_allocs_test(nt, content)
        for k in 0:n
            nt2 = funny_numbers(NamedTuple, k)
            @inferred setproperties(nt, nt2)
            @test Tuple(setproperties(nt, nt2))[1:k] === Tuple(nt2)
            @test setproperties(nt, nt2) isa NamedTuple
            @test length(setproperties(nt, nt2)) == n
            @test Tuple(setproperties(nt, nt2))[k+1:n] === Tuple(nt)[k+1:n]
        end
    end
    @inferred getproperties(funny_numbers(NamedTuple, 100))
    @inferred setproperties(funny_numbers(NamedTuple, 100), funny_numbers(NamedTuple, 90))

    @inferred setproperties(funny_numbers(S,0), funny_numbers(NamedTuple, 0))
    @inferred setproperties(funny_numbers(S,1), funny_numbers(NamedTuple, 1))
    @inferred setproperties(funny_numbers(S,20), funny_numbers(NamedTuple, 18))
    @inferred setproperties(funny_numbers(S,40), funny_numbers(NamedTuple, 38))
    @inferred constructorof(S0)
    @inferred constructorof(S1)
    @inferred constructorof(S20)
    @inferred constructorof(S40)
    if VERSION >= v"1.3"
        @inferred reconstruct(funny_numbers(S,0) , funny_numbers(Tuple,0))
        @inferred reconstruct(funny_numbers(S,1) , funny_numbers(Tuple,1))
        @inferred reconstruct(funny_numbers(S,20), funny_numbers(Tuple,20))
        @inferred reconstruct(funny_numbers(S,40), funny_numbers(Tuple,40))
    end

    @inferred getfields(funny_numbers(S,0))
    @inferred getfields(funny_numbers(S,1))
    @inferred getfields(funny_numbers(S,20))
    @inferred getfields(funny_numbers(S,40))
    @inferred getproperties(funny_numbers(S,0))
    @inferred getproperties(funny_numbers(S,1))
    @inferred getproperties(funny_numbers(S,20))
    @inferred getproperties(funny_numbers(S,40))
end


using StaticArrays, IntervalSets

if isdefined(Base, :get_extension)  # some 1.9 version
    @testset "staticarrays" begin
        sa = @SVector [2, 4, 6, 8]
        sa2 = ConstructionBase.constructorof(typeof(sa))((3.0, 5.0, 7.0, 9.0))
        @test sa2 === @SVector [3.0, 5.0, 7.0, 9.0]

        ma = @MMatrix [2.0 4.0; 6.0 8.0]
        ma2 = @inferred ConstructionBase.constructorof(typeof(ma))((1, 2, 3, 4))
        @test ma2 isa MArray{Tuple{2,2},Int,2,4}
        @test all(ma2 .=== @MMatrix [1 3; 2 4])

        sz = SizedArray{Tuple{2,2}}([1 2;3 4])
        sz2 = @inferred ConstructionBase.constructorof(typeof(sz))([:a :b; :c :d])
        @test sz2 == SizedArray{Tuple{2,2}}([:a :b; :c :d])
        @test typeof(sz2) <: SizedArray{Tuple{2,2},Symbol,2,2}

        for T in (SVector, MVector)
            @test @inferred(ConstructionBase.constructorof(T)((1, 2, 3)))::T == T((1, 2, 3))
            @test @inferred(ConstructionBase.constructorof(T{3})((1, 2, 3)))::T == T((1, 2, 3))
            @test @inferred(ConstructionBase.constructorof(T{3})((1, 2)))::T == T((1, 2))
            @test @inferred(ConstructionBase.constructorof(T{3, Symbol})((1, 2, 3)))::T == T((1, 2, 3))
            @test @inferred(ConstructionBase.constructorof(T{3, Symbol})((1, 2)))::T == T((1, 2))
            @test @inferred(ConstructionBase.constructorof(T{3, X} where {X})((1, 2, 3)))::T == T((1, 2, 3))
            @test @inferred(ConstructionBase.constructorof(T{3, X} where {X})((1, 2)))::T == T((1, 2))
            @test @inferred(ConstructionBase.constructorof(T{X, Symbol} where {X})((1, 2, 3)))::T == T((1, 2, 3))
        end

        sv = SVector(1, 2)
        @test SVector(3.0, 2.0) === @inferred setproperties(sv, x = 3.0)
        @test SVector(3.0, 5.0) === @inferred setproperties(sv, x = 3.0, y = 5.0)
        @test SVector(-1.0, -2.0) === @inferred setproperties(sv, data = (-1.0, -2))
        @test_throws "does not have properties z" setproperties(sv, z = 3.0)
        @test_throws "does not have properties z" setproperties(SVector(1, 2, 3, 4, 5), z = 3.0)
    end

    @testset "intervalsets" begin
        @test constructorof(typeof(1..2))(0.5, 1.5) === 0.5..1.5
        @test constructorof(typeof(OpenInterval(1, 2)))(0.5, 1.5) === OpenInterval(0.5, 1.5)
        @test setproperties(1..2, left=0.0) === 0.0..2.0
        @test setproperties(OpenInterval(1.0, 2.0), left=1, right=5) === OpenInterval(1, 5)
    end
end

module ConstructionBase

export getproperties
export setproperties
export constructorof
export getfields

# Use markdown files as docstring:
for (name, path) in [
    :ConstructionBase => joinpath(dirname(@__DIR__), "README.md"),
    :constructorof => joinpath(@__DIR__, "constructorof.md"),
    :getfields => joinpath(@__DIR__, "getfields.md"),
    :getproperties => joinpath(@__DIR__, "getproperties.md"),
    :setproperties => joinpath(@__DIR__, "setproperties.md"),
]
    # Don't fail when somehow importing docstrings doesn't work (we
    # don't loose any functionalities for that).  We use explicit
    # `@docs` in `docs/src/index.md` to make sure importing docstrings
    # succeeds in CI.
    try
        include_dependency(path)
        str = read(path, String)
        @eval @doc $str $name
    catch err
        @error "Failed to import docstring for $name" exception=(err, catch_backtrace())
    end
end

@generated function constructorof(::Type{T}) where T
    getfield(parentmodule(T), nameof(T))
end

constructorof(::Type{<:Tuple}) = tuple
constructorof(::Type{<:NamedTuple{names}}) where names =
    NamedTupleConstructor{names}()

struct NamedTupleConstructor{names} end

@inline function (::NamedTupleConstructor{names})(args...) where names
    NamedTuple{names}(args)
end

################################################################################
#### getfields
################################################################################
getfields(x::Tuple) = x
getfields(x::NamedTuple) = x
getproperties(o::NamedTuple) = o
getproperties(o::Tuple) = o

if VERSION >= v"1.7"
    function check_properties_are_fields(obj)
        # for ntuples of symbols `===` is semantically the same as `==`
        # but triple equals is easier for the compiler to optimize, see #82
        if propertynames(obj) !== fieldnames(typeof(obj))
            error("""
            The `$(nameof(typeof(obj)))` type defines custom properties: it has `propertynames` overloaded.
            Please define `ConstructionBase.setproperties(::$(nameof(typeof(obj))), ::NamedTuple)` to set its properties.
            """)
        end
    end
else
    function is_propertynames_overloaded(T::Type)::Bool
        T <: NamedTuple && return false
        which(propertynames, Tuple{T}).sig !== Tuple{typeof(propertynames), Any}
    end

    @generated function check_properties_are_fields(obj)
        if is_propertynames_overloaded(obj)
            return quote
                T = typeof(obj)
                msg = """
                The function `Base.propertynames` was overloaded for type `$T`.
                Please make sure the following methods are also overloaded for this type:
                ```julia
                ConstructionBase.setproperties
                ConstructionBase.getproperties # optional in VERSION >= julia v1.7
                ```
                """
                error(msg)
            end
        else
            :(nothing)
        end
    end
end

# dispatch on eltype(names) to select Tuple vs NamedTuple
@inline tuple_or_ntuple(names, vals) = tuple_or_ntuple(eltype(names), names, vals)
# if names are empty (object has no properties): return namedtuple, for backwards compat and generally makes more sense than tuple
@inline tuple_or_ntuple(names::Tuple{}, vals::Tuple) = NamedTuple{names}(vals)

# names are consecutive integers: return tuple
@inline function tuple_or_ntuple(::Type{Int}, names, vals)
    @assert Tuple(names) == ntuple(identity, length(names))
    Tuple(vals)
end
# names are symbols: return namedtuple
@inline tuple_or_ntuple(::Type{Symbol}, names, vals::Tuple) = namedtuple(names, vals...)
@inline tuple_or_ntuple(::Type{Symbol}, names, vals) = NamedTuple{Tuple(names)}(vals)
@inline namedtuple(names, vals...) = NamedTuple{Tuple(names)}((vals...,)) # this seemingly unnecessary method encourages union splitting.
# otherwise: throw an error
tuple_or_ntuple(::Type, names, vals) = error("Only Int and Symbol propertynames are supported")

if VERSION >= v"1.7"
    function getproperties(obj)
        fnames = propertynames(obj)
        tuple_or_ntuple(fnames, getproperty.((obj,), fnames))
    end
    function getfields(obj::T) where {T}
        fnames = fieldnames(T)
        NamedTuple{fnames}(getfield.((obj,), fnames))
    end
else
    @generated function getfields(obj)
        fnames = fieldnames(obj)
        fvals = map(fnames) do fname
             Expr(:call, :getfield, :obj, QuoteNode(fname))
        end
        :(NamedTuple{$fnames}(($(fvals...),)))
    end
    function getproperties(obj)
        check_properties_are_fields(obj)
        getfields(obj)
    end
end

################################################################################
##### setproperties
################################################################################
function setproperties(obj; kw...)
    setproperties(obj, (;kw...))
end

setproperties(obj             , patch::Tuple      ) = setproperties_object(obj     , patch )
setproperties(obj             , patch::NamedTuple ) = setproperties_object(obj     , patch )
setproperties(obj::Tuple      , patch::Tuple      ) = setproperties_tuple(obj      , patch )
setproperties(obj::Tuple      , patch::NamedTuple ) = setproperties_tuple(obj      , patch )

@generated function check_patch_fields_exist(obj, patch)
    fnames = fieldnames(obj)
    pnames = fieldnames(patch)
    pnames ⊆ fnames ? :(nothing) : :(throw(ArgumentError($("Failed to assign fields $pnames to object with fields $fnames."))))
end

function setproperties(obj::NamedTuple{fields}, patch::NamedTuple{fields}) where {fields}
    patch
end

setproperties_tuple(obj::Tuple, patch::NamedTuple{()}) = obj
@noinline function setproperties_tuple(obj::Tuple, patch::NamedTuple)
    msg = """
    setproperties(obj::Tuple, patch::NamedTuple) only allowed for empty NamedTuple. Got:
    obj  ::Tuple      = $obj
    patch::NamedTuple = $patch
    """
    throw(ArgumentError(msg))
end
function setproperties_tuple(obj::NTuple{N,Any}, patch::NTuple{N,Any}) where {N}
    patch
end
append(x,y) = (x..., y...)
@noinline function throw_setproperties_tuple_error(obj, patch)
    msg = """
    Cannot call `setproperties(obj::Tuple, patch::Tuple)` with `length(obj) < length(patch)`. Got:
    obj = $obj
    patch = $patch
    """
    throw(ArgumentError(msg))
end
function setproperties_tuple(obj::NTuple{N,Any}, patch::NTuple{K,Any}) where {N,K}
    if K > N
        throw_setproperties_tuple_error(obj, patch)
    end
    append(patch, after(obj, Val{K}()))
end
function after(xs::Tuple, ::Val{N}) where {N}
    after(Base.tail(xs), Val{N-1}())
end
function after(x::Tuple, ::Val{0})
    x
end

setproperties_object(obj, patch::Tuple{}) = obj
@noinline function setproperties_object(obj, patch::Tuple)
    msg = """
    setproperties(obj, patch::Tuple) only allowed for empty Tuple. Got:
    obj = $obj
    patch = $patch
    """
    throw(ArgumentError(msg))
end
setproperties_object(obj, patch::NamedTuple{()}) = obj

@generated function setfields_object(obj, patch::NamedTuple)
    args = Expr[]
    pnames = fieldnames(patch)
    for fname in fieldnames(obj)
        source = fname in pnames ? :patch : :obj
        push!(args, :(getproperty($source, $(QuoteNode(fname)))))
    end
    :(constructorof(typeof(obj))($(args...)))
end

function setproperties_object(obj, patch::NamedTuple)
    check_properties_are_fields(obj)
    check_patch_fields_exist(obj, patch)
    setfields_object(obj, patch)
end

include("nonstandard.jl")
include("functions.jl")

if !isdefined(Base, :get_extension)
    include("../ext/ConstructionBaseLinearAlgebraExt.jl")
end

end # module

using Documenter, ConstructionBase

makedocs(;
    modules=[ConstructionBase],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/JuliaObjects/ConstructionBase.jl/blob/{commit}{path}#L{line}",
    sitename="ConstructionBase.jl",
    authors="Takafumi Arakaki, Rafael Schouten, Jan Weidner",
    strict=true,
)

deploydocs(;
    repo="github.com/JuliaObjects/ConstructionBase.jl",
)

# Anonymous functions have no `new` constructor. Here we generate
# one for them based on the types of args passed to FunctionConstructor

struct FunctionConstructor{F} end
_isgensym(s::Symbol) = occursin("#", string(s))

@generated function (fc::FunctionConstructor{F})(args...) where F
    isempty(args) && return Expr(:new, F)

    T = getfield(parentmodule(F), nameof(F))
    # We assume all gensym names are anonymous functions
    _isgensym(nameof(F)) || return :($T(args...))
    # Define `new` for rebuilt function type that matches args
    exp = Expr(:new, Expr(:curly, T, args...))
    for i in 1:length(args)
        push!(exp.args, :(args[$i]))
    end
    return exp
end

function ConstructionBase.constructorof(f::Type{F}) where F <: Function
    FunctionConstructor{F}()
end

    constructorof(T::Type) -> constructor

Return an object `constructor` that can be used to construct objects of type `T`
from their field values. Typically `constructor` will be the type `T` with all parameters removed:
```jldoctest
julia> using ConstructionBase

julia> struct T{A,B}
           a::A
           b::B
       end

julia> constructorof(T{Int,Int})
T
```
It is however not guaranteed, that `constructor` is a type at all:
```jldoctest; setup = :(using ConstructionBase)
julia> struct S
           a
           b
           checksum
           S(a,b) = new(a,b,a+b)
       end

julia> ConstructionBase.constructorof(::Type{<:S}) =
           (a, b, checksum=a+b) -> (@assert a+b == checksum; S(a,b))

julia> constructorof(S)(1,2)
S(1, 2, 3)

julia> constructorof(S)(1,2,4)
ERROR: AssertionError: a + b == checksum
```
Instead `constructor` can be any object that satisfies the following properties:
* It must be possible to reconstruct an object from the elements of [`getfields`](@ref):
```julia
ctor = constructorof(typeof(obj))
@assert obj == ctor(getfields(obj)...)
@assert typeof(obj) == typeof(ctor(getfields(obj)...))
```
* The other direction should hold for as many values of `args` as possible:
```julia
ctor = constructorof(T)
getfields(ctor(args...)) == args
```
For instance given a suitable parametric type it should be possible to change
the type of its fields:
```jldoctest; setup = :(using ConstructionBase)
julia> struct T{A,B}
           a::A
           b::B
       end

julia> t = T(1,2)
T{Int64, Int64}(1, 2)

julia> constructorof(typeof(t))(1.0, 2)
T{Float64, Int64}(1.0, 2)

julia> constructorof(typeof(t))(10, 2)
T{Int64, Int64}(10, 2)
```
`constructorof` belongs to [the raw level](@ref the-raw-level).
`constructorof` is generated for all anonymous `Function`s lacking constructors,
identified as having `gensym` `#` in their names. A custom struct `<: Function`
with a `gensym` name may need to define `constructorof` manually.


See also [Tips section in the manual](@ref type-tips)

    getproperties(obj)::NamedTuple
    getproperties(obj::Tuple)::Tuple

Return the properties of `obj` as a `NamedTuple`. Since `Tuple` don't have symbolic properties,
`getproperties` is the identity function on tuples.

# Examples
```jldoctest
julia> using ConstructionBase

julia> struct S
           a
           b
           c
       end

julia> s = S(1, 2, 3)
S(1, 2, 3)

julia> getproperties(s)
(a = 1, b = 2, c = 3)

julia> getproperties((10,20))
(10, 20)
```

## Specification

`getproperties` belongs to [the semantic level](@ref the-semantic-level).
`getproperties` guarantees a couple of invariants. When overloading it, the user is responsible for ensuring them:

1. `getproperties` should be consistent with `Base.propertynames`, `Base.getproperty`, `Base.setproperty!`. 
    Semantically it should be equivalent to:
    ```julia
    function getproperties(obj)
        fnames = propertynames(obj)
        NamedTuple{fnames}(getproperty.(Ref(obj), fnames))
    end
    ```
2. `getproperties` is defined in relation to `setproperties` so that:
   ```julia
   obj == setproperties(obj, getproperties(obj))
   ```
   The only exception from this semantics is that undefined properties may be avoided 
   in the return value of `getproperties`.

# Implementation

`getproperties` is defined by default for all objects. It should be very rare that a custom type `MyType`, has to implement `getproperties(obj::MyType)`. Reasons to do so are undefined fields or performance considerations.

    setproperties(obj, patch::NamedTuple)


Return a copy of `obj` with properties updated according to `patch`.

# Examples
```jldoctest
julia> using ConstructionBase

julia> struct S
           a
           b
           c
       end

julia> s = S(1,2,3)
S(1, 2, 3)

julia> setproperties(s, (a=10,c=4))
S(10, 2, 4)

julia> setproperties((a=1,c=2,b=3), (a=10,c=4))
(a = 10, c = 4, b = 3)
```

There is also a convenience method, which builds the `patch` argument from
keywords:

    setproperties(obj; kw...)

# Examples
```jldoctest
julia> using ConstructionBase

julia> struct S
           a
           b
           c
       end

julia> o = S(10, 2, 4)
S(10, 2, 4)

julia> setproperties(o, a="A", c="cc")
S("A", 2, "cc")
```

## Specification

`setproperties` belongs to [the semantic level](@ref the-semantic-level). If satisfies the following invariants:

1. Purity: `setproperties` is supposed to have no side effects. In particular `setproperties(obj, patch::NamedTuple)` may not mutate `obj`.
2. Relation to `propertynames` and `fieldnames`: `setproperties` relates to `propertynames` and `getproperty`, not to `fieldnames` and `getfield`.
   This means that any subset `p₁, p₂, ..., pₙ` of `propertynames(obj)` is a valid set of properties, with respect to which the lens laws below must hold.
3. `setproperties` is defined in relation to `getproperties` so that:
   ```julia
   obj == setproperties(obj, getproperties(obj))
   ```
4. `setproperties` should satisfy the lens laws:

For any valid set of properties `p₁, p₂, ..., pₙ`, following equalities must hold:

* You get what you set.

```julia
let obj′ = setproperties(obj, ($p₁=v₁, $p₂=v₂, ..., $pₙ=vₙ))
    @assert obj′.$p₁ == v₁
    @assert obj′.$p₂ == v₂
    ...
    @assert obj′.$pₙ == vₙ
end
```

* Setting what was already there changes nothing:

```julia
@assert setproperties(obj, ($p₁=obj.$p₁, $p₂=obj.$p₂, ..., $pₙ=obj.$pₙ)) == obj
```

* The last set wins:
```julia
let obj′ = setproperties(obj, ($p₁=v₁, $p₂=v₂, ..., $pₙ=vₙ)),
    obj′′ = setproperties(obj′, ($p₁=w₁, $p₂=w₂, ..., $pₙ=wₙ))
    @assert obj′′.$p₁ == w₁
    @assert obj′′.$p₂ == w₂
    ...
    @assert obj′′.$pₙ == wₙ
end
```

# Implementation

For a custom type `MyType`, a method `setproperties(obj::MyType, patch::NamedTuple)`
may be defined. When doing so it is important to ensure compliance with the specification.

* Prefer to overload [`constructorof`](@ref) whenever makes sense (e.g., no `getproperty`
  method is defined).  Default `setproperties` is defined in terms of `constructorof` and `getproperties`.

* If `getproperty` is customized, it may be a good idea to define `setproperties`.

!!! warning
    The signature `setproperties(obj::MyType; kw...)` should never be overloaded.
    Instead `setproperties(obj::MyType, patch::NamedTuple)` should be overloaded.

# ConstructionBase.jl

[`ConstructionBase`](@ref) allows flexible construction and destructuring of objects.
There are two levels of under which this can be done:
### [The raw level](@id the-raw-level)
This is where `Base.fieldnames`, `Base.getfield`, `Base.setfield!` live.
This level is what an object is ultimately composed of including all private details.
At the raw level [`ConstructionBase`](@ref) adds [`constructorof`](@ref) and [`getfields`](@ref).
### [The semantic level](@id the-semantic-level)
This is where `Base.propertynames`, `Base.getproperty` and `Base.setproperty!` live. This level is typically the public interface of a type, it may hide private details and do magic tricks.
At the semantic level [`ConstructionBase`](@ref) adds [`setproperties`](@ref) and [`getproperties`](@ref).


## Interface

```@index
```

```@docs
ConstructionBase
ConstructionBase.constructorof
ConstructionBase.getfields
ConstructionBase.getproperties
ConstructionBase.setproperties
```

## [Tips for designing types](@id type-tips)

When designing types from scratch, it is often possible to structure the types
in such a way that overloading `constructorof` or `setproperties` is unnecessary
in the first place.  It let types in your package work nicely with the ecosystem
built on top of `ConstructionBase` even without explicitly depending on it.
For simple `struct`s whose type parameters can be determined from field values,
`ConstructionBase` works without any customization, provided that the "type-less"
constructor exists.  However, it is often useful or required to have type
parameters that cannot be determined from field values. One way to solve this
problem is to define singleton types that would determine the type parameters:

```jldoctest tips
abstract type OutputBy end
struct Mutating <: OutputBy end
struct Returning <: OutputBy end

struct Add{O <: OutputBy, T}
    outputby::O
    value::T
end

(f::Add{Mutating})(y, x) = y .= x .+ f.value
(f::Add{Returning})(x) = x .+ f.value

add1! = Add(Mutating(), 1)

using ConstructionBase
add2 = constructorof(typeof(add1!))(Returning(), 2)
add2(1)

# output

3
```

`setproperties` works as well:

```jldoctest tips
add3 = setproperties(add2; value=3)
add3(1)

# output

4
```

Note that no overloading of `ConstructionBase` functions was required.
Importantly, this also provides an interface to change type parameters
out-of-the-box:

```jldoctest tips
add3! = setproperties(add3; outputby=Mutating())
add3!([0], 1)

# output

1-element Vector{Int64}:
 4
```

Furthermore, it would work with packages depending on `ConstructionBase` such
as [Setfield.jl](https://github.com/jw3126/Setfield.jl).

```jldoctest tips
using Setfield: @set
add3′ = @set add3!.outputby = Returning()
add3′ === add3

# output

true
```

!!! note

    If it is desirable to keep fields as an implementation detail, combining
    trait functions and
    [`Setfield.FunctionLens`](https://jw3126.github.io/Setfield.jl/latest/#Setfield.FunctionLens)
    may be useful:

    ```jldoctest tips
    OutputBy(x) = typeof(x)
    OutputBy(::Type{<:Add{O}}) where O = O()

    using Setfield: Setfield, @lens
    Setfield.set(add::Add, ::typeof(@lens OutputBy(_)), o::OutputBy) =
        @set add.outputby = o

    obj = (add=add3!,)
    obj′ = @set OutputBy(obj.add) = Returning()
    obj′ === (add=add3,)

    # output

    true
    ```

    ```jldoctest tips
    Setfield.set(::Type{Add{O0, T}}, ::typeof(@lens OutputBy(_)), ::O1) where {O0, T, O1 <: OutputBy} =
        Add{O1, T}

    T1 = typeof(add3!)
    T2 = @set OutputBy(T1) = Returning()
    T2 <: Add{Returning}

    # output

    true
    ```

    getfields(obj) -> NamedTuple
    getfields(obj::Tuple) -> Tuple

Return a `NamedTuple` containing the fields of `obj`. On `Tuples` `getfields` is
the identity function instead, since `Tuple` fields have no symbolic names.

# Examples
```jldoctest
julia> using ConstructionBase

julia> struct S{A,B}
           a::A
           b::B
       end

julia> getfields(S(1,2))
(a = 1, b = 2)

julia> getfields((a=10,b=20))
(a = 10, b = 20)

julia> getfields((4,5,6))
(4, 5, 6)
```

# Specification

`getfields` belongs to the [the raw level](@ref the-raw-level).
Semantically `getfields` boils down to `getfield` and `fieldnames`:
```julia
function getfields(obj::T) where {T}
    fnames = fieldnames(T)
    NamedTuple{fnames}(getfield.(Ref(obj), fnames))
end
```
However the actual implementation can be more optimized. For builtin types, there can also be deviations from this semantics:
* `getfields(::Tuple)::Tuple` since `Tuples` don't have symbolic fieldnames
* There are some types in `Base` that have `undef` fields. Since accessing these results in an error, `getfields` instead just omits these.

# Implementation

The semantics of `getfields` should not be changed for user defined types. It should 
return the raw fields as a `NamedTuple` in the struct order. In other words it should be
equivalent to
```julia
function getfields(obj::T) where {T}
    fnames = fieldnames(T)
    NamedTuple{fnames}(getfield.(Ref(obj), fnames))
end
```
even if that includes private fields of `obj`.
If a change of semantics is desired, consider overloading [`getproperties`](@ref) instead.
See also [`getproperties`](@ref), [`constructorof`](@ref)
